<?php

/**
 * hidden submenu to handle oauth callback
 * - use submenu capability to handle security (admin only) 
 * 
 */

use QPMN\Partner\Libs\QPMN\OAuth\API\Me;
use QPMN\Partner\Libs\QPMN\OAuth\AuthCodePKCE;
use QPMN\Partner\WC\API\QPMN\Account;
use QPMN\Partner\WC\QP_WP_Option_Account;
use QPMN\Partner\WC\QP_WP_Option_QPMN_Token;

try {

	if (isset($_GET['code'])) {

		$code = sanitize_text_field($_GET['code']);
		$state = sanitize_text_field($_GET['state']);
		//verify $state
		$isValidedRequeset = AuthCodePKCE::verifyNonce($state, AuthCodePKCE::NONCE_ACTION);
		if ($isValidedRequeset) {
			$userLoginInfo = QP_WP_Option_Account::getLoginInfo();
			$clientId = $userLoginInfo[Account::CLIENT_ID];
			$verifier = QP_WP_Option_Account::getCodeVerifier();

			$authCodePKCE = new AuthCodePKCE($clientId, $verifier);

			//store access token as transient option
			//store access token scope and type
			//store refresh token as transient option
			$tokens = $authCodePKCE->token($code);
			if (isset($tokens['error'])) {
				throw new Exception($tokens['error_description'], 403);
			}

			try {
				//get me
				$meObj = new Me($tokens['access_token']);
				$me = $meObj->me();
				if (is_array($me) && isset($me['display_name'])) {
					QP_WP_Option_Account::saveAndUpdate($me['display_name'], QP_WP_Option_Account::PARTNER_NAME);
				}
			} catch (Exception $e) {
				//no display name
			}
			//save tokens 
			QP_WP_Option_QPMN_Token::setTokens($tokens);

			wp_redirect('admin.php?page=qpmn_options');
		} else {
			//request not init from us 
		}
	}
} catch (Exception $e) {
	print_r($e->getMessage());
}
